﻿
using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using customeventET;
using MVR.FileManagementSecure;
using Random2 = System.Random;
using Random = UnityEngine.Random;

namespace SPQR
{
    public class AliveTriggers : MVRScript
    {


        public bool run;

        public bool aeternumSelected = false;

        public Atom PersonAtom;


        public MVRScript pluginAlive;


        public Colorworks colorworks_p67;
        public UIworks uiworks_p67;
        public Playergazeworks playergazeworks_p67;
        public Triggerworks triggerworks_p67;


        public bool debugMode_p67 = false;
        public bool debugStopMode_p67 = false;
        public bool initblinkEnabled_p67 = false;


        public JSONStorableString jstring_p67;
        public JSONStorableString jstring2_p67;


        public float aliveTease = 0f;
        public float aliveCaress = 0f;
        public float aliveSpank = 0f;

        public Dictionary<string, FreeControllerV3> bodyParts_p67 = new Dictionary<string, FreeControllerV3>(){};

        public string[] tickletriggers_p67 = new string[] { "None", "Light", "Medium", "High", "MAX" };
        //public string[] areas_p67 = new string[] { "head", "neck", "chest", "abdomen", "thighs", "shoulders", "forearms", "hands", "shins", "feet", "hip", "breasts", "gens", "glutes" };
        public List<string> choicesMeters_p67 = new List<string>(new string[] { "None", "Light", "Medium", "High", "MAX" });
        public string[] aliveSliders = new string[] { "tease", "arouse", "pain" };



        /* collision */
        public JSONStorableString collisionsLog_p67;
        public JSONStorableBool collisionsLogBool_p67;
        public JSONStorableString AliveStatus_p67;
        public float collisionThreshold_p67 = 0.05f;
        public float collisionCooldown_p67 = 0.33f;


        public float myClock_p67 = -1.0f;


        public string SavePath_p67 = "Saves\\PluginData\\AliveExtraTriggers";
        public string SaveExtension_p67 = "json";
        public GenerateDAZMorphsControlUI morphControl_p67;

        public Dictionary<string, EventTrigger> myEventTriggers_p67 = new Dictionary<string, EventTrigger>();
        public Dictionary<string, JSONStorableStringChooser> choosers_p67 = new Dictionary<string, JSONStorableStringChooser>();

        public string personId_p67;

        public Dictionary<string, bool> flags_p67 = new Dictionary<string, bool>()
        {
        };

       
        /* other */

        public bool gameIsVR_p67;

        GameObject playerHands_p67;

        protected JSONStorableString myString_p67;


        Dictionary<string, float> clicks_p67 = new Dictionary<string, float>();
        private float downClickTime_p67;
        private float ClickDeltaTime_p67 = 1f;

        public Dictionary<string, JSONStorableBool> enableFeatures_p67 = new Dictionary<string, JSONStorableBool>();

        public Dictionary<string, JSONStorableString> strings_p67 = new Dictionary<string, JSONStorableString>();

        public Dictionary<string, UIDynamicButton> buttons_p67 = new Dictionary<string, UIDynamicButton>();

        public Dictionary<string, JSONStorableFloat> sliders_p67 = new Dictionary<string, JSONStorableFloat>();

        public Dictionary<string, float> timeline_p67 = new Dictionary<string, float>() {
            {"triggerVagina",0f},

            {"doplustease",0f},
            {"doplusarouse",0f},
            {"dopluspain",0f},
            {"dominustease",0f},
            {"dominusarouse",0f},
            {"dominuspain",0f},

            {"spankexpression", 0f },
            {"touchexpression", 0f }
        };

        public string[] areas_p67 = new string[] { "head", "neck", "chest", "abdomen", "thighs", "shoulders", "forearms", "hands", "shins", "feet", "hip", "breasts", "gens", "glutes" };
        



        public string[] touchtypes_p67 = new string[] { "tease", "caress", "spank" };
      
     
        public Dictionary<string, string> ephemeralString_p67 = new Dictionary<string, string>() {
            {"currentContact", ""},
        };

        public string scriptkey_p67;

        public string DictionaryGetRandomString_p67(Dictionary<string, string> d)
        {

            Random2 rnd = new Random2();
            int index = rnd.Next(d.Count);
            return d.ElementAt(index).Value;
        }

        public string DictionaryGetRandomStringKey_p67(Dictionary<string, float> d)
        {

            Random2 rnd = new Random2();
            int index = rnd.Next(d.Count);
            return d.ElementAt(index).Key;
        }


       

        public static float Clamp_p67(float value, float min, float max)
        {
            return (value < min) ? min : (value > max) ? max : value;
        }
       
        public string AtomUidAddSuffix_p67(string s)
        {
            s += "-" + personId_p67;
            return s;
        }

        public override void Init()
        {
            if(containingAtom.type != "Person")
            {
                SuperController.LogError("This plugin must be added on a Person atom");
                return;
            }
            PersonAtom = SPQRUtils.GetAtomById_p67(containingAtom.uid);
            personId_p67 = PersonAtom.uid;


            colorworks_p67 = new Colorworks(this);
            uiworks_p67 = new UIworks(this);
            playergazeworks_p67 = new Playergazeworks(this);
            triggerworks_p67 = new Triggerworks(this);

            if (PersonAtom.type != "Person") return;

            bodyParts_p67["head"] = PersonAtom.GetStorableByID("headControl") as FreeControllerV3;
            bodyParts_p67["chest"] = PersonAtom.GetStorableByID("chestControl") as FreeControllerV3;
            bodyParts_p67["hip"] = PersonAtom.GetStorableByID("hipControl") as FreeControllerV3;
            bodyParts_p67["lArm"] = PersonAtom.GetStorableByID("lArmControl") as FreeControllerV3;
            bodyParts_p67["rArm"] = PersonAtom.GetStorableByID("rArmControl") as FreeControllerV3;
            bodyParts_p67["lHand"] = PersonAtom.GetStorableByID("lHandControl") as FreeControllerV3;
            bodyParts_p67["rHand"] = PersonAtom.GetStorableByID("rHandControl") as FreeControllerV3;
            bodyParts_p67["lFoot"] = PersonAtom.GetStorableByID("lFootControl") as FreeControllerV3;
            bodyParts_p67["rFoot"] = PersonAtom.GetStorableByID("rFootControl") as FreeControllerV3;




            gameIsVR_p67 = XRSettings.isDeviceActive && !string.IsNullOrEmpty(XRSettings.loadedDeviceName);

            uiworks_p67.InitUI_p67();


            SimpleTriggerHandler.LoadAssets_p67();


            SuperController.singleton.onAtomUIDRenameHandlers += OnAtomRename;

            UIUpdate_p67();
            Initialize_p67();           
        }

        private void UIUpdate_p67()
        {
        }

        private void OnAtomRename(string oldid, string newid)
        {

           
            foreach (var item in myEventTriggers_p67)
            {
                item.Value.SyncAtomNames();
            }



        }


        public override JSONClass GetJSON(bool includePhysical = true, bool includeAppearance = true, bool forceStore = false)
        {
            JSONClass jc = base.GetJSON(includePhysical, includeAppearance, forceStore);
            if (includePhysical || forceStore)
            {
                needsStore = true;
                foreach (var item in myEventTriggers_p67)
                {
                    jc[item.Value.Name] = item.Value.GetJSON(base.subScenePrefix);
                }

            }
            return jc;
        }

        void Start()
        {
           
            InvokeRepeating("UpdateSecond5s_p67", 1f, 5f);
            InvokeRepeating("UpdateSecond_p67", 1f, 1f);
            InvokeRepeating("UpdateConstant_p67", 1f, 1f / 30f);
            InvokeRepeating("UpdateConstant5_p67", 1f, 1f / 5f);

        }

        int second = 0;

        void UpdateSecond5s_p67()
        {
            if (IsDisabled_p67()) return;
            pluginAlive = SPQRUtils.GetPlugin_p67(containingAtom,"SPQR.Alive");

        }
        void UpdateSecond_p67()
        {
            if (IsDisabled_p67()) return;

          

            try
            {
                second = ++second % 60;

            }
            catch (Exception e)
            {
                SuperController.LogError("err:" + e);
            }
            //  eyeworks_p67.getHeadAngle_p67(); // temp

        }

        void UpdateConstant_p67()
        {
            if (IsDisabled_p67()) return;
            try
            {
              
               
            } catch(Exception e)
            {
               // SuperController.LogError("error uc: " + e);
            }
        }


        void UpdateConstant5_p67()
        {
            if (IsDisabled_p67()) return;

            if (pluginAlive != null)
            {
                processAliveValues();
            }


            playergazeworks_p67.UpdateConstant5_p67();
        }

        public void processAliveValues()
        {
            if (pluginAlive == null) return;
            try
            {
                aliveTease = pluginAlive.GetFloatParamValue("Tease Level");
                aliveCaress = pluginAlive.GetFloatParamValue("Arousal Level");
                aliveSpank = pluginAlive.GetFloatParamValue("Discomfort Level");



            foreach (var type in aliveSliders)
            {
                var prev = choosers_p67[type].val;
                var val = aliveTease;
                var touchType = "tease";
                if (type == "arouse")
                {
                    val = aliveCaress;
                    touchType = "caress";
                }
                if (type == "pain")
                {
                    touchType = "spank";
                    val = aliveSpank;
                }

                if (val == 0f) choosers_p67[type].val = "None";
                else if (val < 50f) choosers_p67[type].val = "Light";
                else if (val < 80f) choosers_p67[type].val = "Medium";
                else if (val < 100f) choosers_p67[type].val = "High";
                else choosers_p67[type].val = "MAX";
                var now = choosers_p67[type].val;

                if (prev != now)
                {
                    RaeTriggerTrigger_p67(now, touchType);
                }

            }

            }
            catch (Exception e)
            {
                SuperController.LogError("e:" + e);
            }

            printAliveValues();            

        }
        public void printAliveValues()
        {

            if (pluginAlive != null)
            {
                AliveStatus_p67.val = "Alive Status: <color=\"#66FF66\">Connected</color> \n\n" +
                    "tease: " + aliveTease + "\n" +
                    "arousal: " + aliveCaress+ "\n" +
                    "discomfort: " + aliveSpank + "\n";
            }
            else
            {
                AliveStatus_p67.val = "Alive Status: <color=\"#FF6666\">Not Connected</color>";
            }
        }
        public bool IsDisabled_p67()
        {
            if (containingAtom.type != "Person") return true;
            if (SuperController.singleton.freezeAnimationToggle.isOn) return true;
            if (!enabledJSON.val) return true;
      

            if (run == true)
            {
                DeleteColliders_p67();
            }

            return false;
        }

        void Update()
        {

            //if (Input.GetKeyDown(KeyCode.F7))
            //{
            //    poseworks_p67.LoadRandomIdlePose_p67();
            //}

            try
            {
                
                foreach (var item in myEventTriggers_p67)
                {
                    myEventTriggers_p67[item.Key].Update();
                }

                if (myClock_p67 > 0.0f)
                {
                    myClock_p67 -= Time.deltaTime;
                }

              
                playergazeworks_p67.Update_p67();

                AEClick_p67();


            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }



      

        private void TestTrigger_p67()
        {
        }


        void FixedUpdate()
        {
            if (IsDisabled_p67()) return;
            try
            {
                playergazeworks_p67.FixedUpdate_p67();
            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void OnEnable()
        {
            Initialize_p67();
            playergazeworks_p67.OnEnable_p67();
        }


        void Initialize_p67()
        {
            run = true;
            scriptkey_p67 = SPQRUtils.CreateMD5Hash_p67(SPQRUtils.Timestamp_p67().ToString());
            RefreshColliders_p67();
        }

        void writeDebug_p67(string s)
        {
            var path = @"Saves\PluginData\AliveDebug\";
            if (!FileManagerSecure.DirectoryExists(path)) FileManagerSecure.CreateDirectory(path);
            FileManagerSecure.WriteAllText(path + "debug.txt", s);
        }

        void DeleteColliders_p67()
        {
            try
            {
                run = false;
                //BroadcastMessage("OnCollideAliveStop", true);
                if (PersonAtom == null) return;
              
                PersonAtom.GetComponentsInChildren<Rigidbody>().ToList().ForEach(f =>
                {
                    if (f.gameObject == null) return;
                    var tc = f.gameObject.GetComponent<TriggerCollideET>();
                    if (tc == null) return;
                    tc.Clear();
                    Destroy(tc);
                });

            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }
        }

        void OnDisable()
        {
            playergazeworks_p67.OnDisable_p67();
            //SuperController.LogMessage("OnDisable_p67");
            // PersonAtom.GetComponentsInChildren<Rigidbody>().ToList().ForEach(f =>
            // {
            //     try{
            //         f.gameObject.GetComponent<TriggerCollideET>().Clear();
            //     } catch(Exception e){

            //     }
            // });

            DeleteColliders_p67();
        }


        void OnDestroy()
        {
            SuperController.singleton.onAtomUIDRenameHandlers -= OnAtomRename;
            DeleteColliders_p67();
            CancelInvoke();         
            playergazeworks_p67.OnDestroy_p67();           
            foreach (var item in myEventTriggers_p67)
            {
                myEventTriggers_p67[item.Key].Remove();
            }
         
        }




        public override void LateRestoreFromJSON(JSONClass jc, bool restorePhysical = true, bool restoreAppearance = true, bool setMissingToDefault = true)
        {
            base.LateRestoreFromJSON(jc, restorePhysical, restoreAppearance, setMissingToDefault);
            if (!base.physicalLocked && restorePhysical && !IsCustomPhysicalParamLocked("trigger"))
            {

                foreach (var item in myEventTriggers_p67)
                {
                    myEventTriggers_p67[item.Key].RestoreFromJSON(jc, base.subScenePrefix, base.mergeRestore, setMissingToDefault);
                }
               
            }


        }




        public void AEClick_p67()
        {
            //if (Input.GetKey(KeyCode.LeftShift) || Input.GetKey(KeyCode.LeftControl) || Input.GetKey(KeyCode.LeftAlt)) return;
            Plane plane = new Plane(SuperController.singleton.MonitorCenterCamera.transform.forward, 0f);
            Plane plane2 = new Plane(Vector3.up, 0);
            //Plane plane = new Plane(Camera.main.transform.forward, 0);
            if (Input.GetMouseButtonDown(1))
            {
                downClickTime_p67 = Time.time;
            }
            if (Input.GetMouseButtonUp(1))
            {
                if (Time.time - downClickTime_p67 <= ClickDeltaTime_p67)
                {

                    
                    float distance;
                    RaycastHit raycastHit = new RaycastHit();
                    bool found = false;
                    Vector3 worldPosition;
                    if (Camera.main == null) return;
                    if (Input.mousePosition == null) return;
                    Ray ray = Camera.main.ScreenPointToRay(Input.mousePosition);

                    //Ray ray = SuperController.singleton.MonitorCenterCamera.ScreenPointToRay(Input.mousePosition);
                   // SuperController.LogMessage("ray: " + ray.ToString());
                    //SuperController.LogMessage("camp "+Camera.main.transform.position.ToString()+ " -r - "+ Camera.main.transform.localEulerAngles.ToString());


                    if (plane.Raycast(ray, out distance) || plane2.Raycast(ray, out distance))
                    {

                            
                        worldPosition = ray.GetPoint(distance);
                        if (worldPosition == null) return;

                        RaycastHit[] hits = Physics.RaycastAll(ray, 10f);
                        if (hits.Length > 0)
                        {
                            //SuperController.LogMessage("HITS COUNT = " + hits.Length);
                            foreach (RaycastHit hit in hits)
                            {
                                var a = SPQRUtils.getAtomFromTransform_p67(hit.collider.gameObject.transform);
                                //    SuperController.LogMessage("HITc: " + hit.collider.name +" - "+ a.name);
                                if (hit.collider.name == "Plane") continue;
                                if (hit.collider.name == "Floor") continue;
                                if (hit.collider.name == "HardCollider") continue;
                                if (hit.collider.name == "_ColliderHair") continue;
                                if (hit.collider.name.Contains("HeadHair")) continue;
                                if (hit.collider.name.Contains("link") || hit.collider.name.Contains("Link")) continue;
                                if (hit.collider.name.Contains("control") || hit.collider.name.Contains("Control")) continue;
                                // SuperController.LogMessage("HITc: " + hit.collider);
                                if (!found)
                                {
                                    raycastHit = hit;
                                    found = true;
                                    break;
                                }
                            }
                        }
                        else
                        {
                            // SuperController.LogMessage("NOHITS: ");
                        }

                        if (found)
                        {

                            CurrentClickedGameObject_p67(worldPosition, ray, raycastHit.transform.gameObject, raycastHit.collider);
                        }


                        // if (Physics.Raycast(ray, out raycastHit, 100f))
                        // {
                        //     if (raycastHit.transform != null)
                        //     {
                        //         CurrentClickedGameObject_p67(worldPosition, ray, raycastHit.transform.gameObject, raycastHit.collider);
                        //     }
                        // }
                    }
                }

            }
        }
        public void RefreshColliders_p67()
        {
            DeleteColliders_p67();
            PersonAtom.GetComponentsInChildren<Rigidbody>().ToList().ForEach(f =>
            {
                try
                {
                    f.gameObject.AddComponent<TriggerCollideET>().OnCollideAlive += ObserveTrigger_p67;
                    var tc = f.gameObject.GetComponent<TriggerCollideET>();
                    tc.SetScriptkey(scriptkey_p67);
                    tc.setSuffix(personId_p67);
                    SPQRUtils.setAtomStorableString_p67(AtomUidAddSuffix_p67("VirtualdollGlobalData"), "Text", "text", scriptkey_p67);
                }
                catch (Exception e)
                {
                }
            });


            //Rigidbody lipRB = PersonAtom.rigidbodies_p67.First(rb => rb.name == "LipTrigger");
            //var lipCollider = lipRB.gameObject.AddComponent<TriggerCollideET>();
            //lipCollider.OnCollideAlive += ObserveTriggerLips;


        }





        void ObserveTrigger_p67(object sender, TriggerEventArgs e)
        {
            try
            {
                if (!enabledJSON.val) return;
                Atom parent = null;
                if (myClock_p67 > 0f) return;
                
                if (e == null) return;
                if (e.collider == null) return;
                foreach (var component in e.collider.gameObject.GetComponentsInParent<Component>())
                {
                    if (component == null) continue;
                    var atom = component as Atom;
                    if (atom != null)
                    {
                        parent = atom;
                        break;
                    }
                }





                var found = "";

                var RB = e.collider.attachedRigidbody;


                foreach (var xatom in SuperController.singleton.GetAtoms())
                {
                    var RB2 = xatom.rigidbodies.First();
                    if (RB == RB2)
                    {
                        found = xatom.name;
                        break;
                    }

                }


                if (e.evtType == customeventET.EventType.ENTERED)
                {
                    var sn = sender.ToString().Replace(" (customeventET.TriggerCollideET)", "");

                    if (!triggerworks_p67.customTriggerAllowed_p67(sn))
                    {
                        return;
                    }
                    RaeClickTouch_p67("trigger", PersonAtom.name, PersonAtom.type, sender.ToString(), 0.1f, e.collider);
                    return;
                }
                if (e.evtType == customeventET.EventType.HIT)
                {

                    float level = 0f;

                    if (e.collision != null)
                    {
                        level = e.collision.relativeVelocity.magnitude / 3.0f;
                    }

                    if (level > sliders_p67["treshold1"].val && level < sliders_p67["treshold2"].val)
                    {
                        //if (level > 3) level = 3;

                        //SuperController.LogMessage("collide at high level: " + level + ", threshold: " + collisionThreshold_p67.val);

                        /*
                        foreach(var contactpoint in e.collision.contacts){
                            SuperController.LogMessage(contactpoint.thisCollider.attachedRigidbody.name + " with " + contactpoint.otherCollider.attachedRigidbody.name);
                        }
                        */

                        var xname = found.Length > 0 ? found : parent.name;

                        var parentAtom = SPQRUtils.GetAtomById_p67(xname);
                        if (parentAtom != null)
                        {
                            if (parentAtom.type == "Slate" || parentAtom.type == "Floor" || parentAtom.type == "WoodPanel" || parentAtom.type == "ReflectiveSlate" || parentAtom.type == "ReflectiveWoodPanel")
                            {
                                return;
                            }
                        }

                        var xcollider = e.collider.name;
                        if (e.collision != null)
                        {
                            if (e.collision.contacts.Count() > 0)
                            {
                                xcollider = e.collision.contacts[0].otherCollider.attachedRigidbody.name;
                            }
                        }
                        //RaeClickTouch_p67(sender.ToString(), xname, parent.type, xcollider, level);

                        RaeClickTouch_p67(xname, PersonAtom.name, PersonAtom.type, sender.ToString(), level, e.collider);

                        //SuperController.LogMessage("!!!!!Receiving event " + parent.name + " of " + found + " of " + e.collider.name);
                        // SuperController.LogMessage("Collide with other object");

                    }
                    else
                    {

                    }
                }
                else { }
            }
            catch (Exception err)
            {
                //  E("err: " + err);
            }
        }




        //////////////////////////////////////////////


        public string RandomFromString_p67(string[] elements)
        {
            Random2 rnd = new Random2();
            int index = rnd.Next(elements.Length);
            return elements[index];
        }



        public void RaeTriggerTrigger_p67(string s, string type = "tease")
        {

            if (myEventTriggers_p67.ContainsKey("on" + type + s))
            {
                myEventTriggers_p67["on" + type + s].Trigger();
            }

            if (buttons_p67.ContainsKey("on" + type + s))
            {
                if (buttons_p67["on" + type + s] == null) return;
                buttons_p67["on" + type + s].buttonColor = new Color(0.2f, 0.9f, 0.2f);
                StartCoroutine(CoroutineFlashButton_p67(s, type));
            }

        }

        private IEnumerator CoroutineFlashButton_p67(string s, string type = "tease")
        {
            yield return StartCoroutine(Wait_p67(0.5f));
            buttons_p67["on" + type + s].buttonColor = new Color(0.839f, 0.839f, 0.839f);
        }

        IEnumerator Wait_p67(float seconds)
        {
            yield return new WaitForSeconds(seconds);
        }



        void RaeClickTouch_p67(string sender, string name, string type, string collider, float level, Collider c = null)
        {


            if (c != null)
            {
                //if (c.name == "AutoColliderAutoCollidersHeadHard13Hard" || c.name == "AutoColliderAutoCollidersHeadHard10Hard" || c.name == "AutoColliderAutoCollidersHeadHard9Hard" || c.name == "AutoColliderAutoCollidersHeadHard8Hard" || c.name == "AutoColliderAutoCollidersHeadHard7Hard")
                //{
                //    htmlworks_p67.ToggleUI_p67();
                //}
            }
            //  SuperController.LogMessage("RaeClickTouch_p67:" + sender + " "+name +" "+ type+" "+collider+" "+level);
            try
            {
                var slevel = String.Format("{0:0.000}", level);
                sender = sender.Replace(" (customeventET.TriggerCollideET)", "");
                collider = collider.Replace(" (customeventET.TriggerCollideET)", "");

                bool isSelfTouch = false;
                if (sender == PersonAtom.name && sender != "click") isSelfTouch = true;



                string touchType = "none";
                string touchMeter = "none";
                if (level > sliders_p67["touchdetection_tease"].val)
                {
                    touchType = "tease";
                    touchMeter = "tease";
                }
                if (level > sliders_p67["touchdetection_caress"].val)
                {
                    touchType = "caress";
                    touchMeter = "none";
                }
                if (level > sliders_p67["touchdetection_spank"].val)
                {
                    touchType = "spank";
                    touchMeter = "pain";
                }





               



                if (touchType == "none") return;


             

                // SuperController.LogMessage("touchMeter:"+touchMeter);


                if (collisionsLogBool_p67.val)
                {
                    var s = "" + sender + " collision (" + slevel + ") " + touchType + ":  \n" + type + ":" + name + ":"
                    + collider + "\n\n" + collisionsLog_p67.val;

                    if (s.Length > 500)
                    {
                        s = s.Substring(0, 500);
                    }
                    collisionsLog_p67.val = s;

                }

                var reaction_type = "reaction_" + touchType;

                //if (actionworks_p67.cooldowns_p67["penetration"] > 0f)



                //if (enableFeatures_p67["autoride"].val)
                //{
                //    if (triggerworks_p67.vanillaTriggerIsOn_p67("DeepVaginaTrigger") & triggerworks_p67.vanillaTriggerIsOn_p67("VaginaTrigger"))
                //    {
                //        if (!enableFeatures_p67["command_ridegentle_enable"].val && !enableFeatures_p67["command_ride_enable"].val)
                //        {

                //            StartCoroutine(CoroutineActivateAutoride_p67(this, 1f));
                //        }
                //    }
                //}





                if (enableFeatures_p67["head"].val && (collider.Contains("head") || collider.Contains("lowerJaw")))
                {
                    RaeTriggerTrigger_p67("head", touchType);

                }
                else if (enableFeatures_p67["chest"].val && collider.Contains("chest"))
                {
                    RaeTriggerTrigger_p67("chest", touchType);
                }
                else if (enableFeatures_p67["neck"].val && collider.Contains("neck"))
                {
                    RaeTriggerTrigger_p67("neck", touchType);

                }
                else if (enableFeatures_p67["abdomen"].val && collider.Contains("Collidersabdomen"))
                {
                    RaeTriggerTrigger_p67("abdomen", touchType);
                }
                else if (enableFeatures_p67["thighs"].val && collider.Contains("ColliderslThigh"))
                {
                    RaeTriggerTrigger_p67("thighs", touchType);
                }
                else if (enableFeatures_p67["thighs"].val && collider.Contains("CollidersrThigh"))
                {
                    RaeTriggerTrigger_p67("thighs", touchType);
                }
                else if (enableFeatures_p67["breasts"].val && (collider.Contains("Pectoral") || collider.Contains("areola") || collider.Contains("nipple")))
                {
                    RaeTriggerTrigger_p67("breasts", touchType);
                }

                else if (enableFeatures_p67["shoulders"].val && collider.Contains("lShldr"))
                {
                    RaeTriggerTrigger_p67("shoulders", touchType);
                }
                else if (enableFeatures_p67["shoulders"].val && collider.Contains("rShldr"))
                {
                    RaeTriggerTrigger_p67("shoulders", touchType);
                }
                else if (enableFeatures_p67["forearms"].val && collider.Contains("lForeArm"))
                {
                    RaeTriggerTrigger_p67("forearms", touchType);
                }
                else if (enableFeatures_p67["forearms"].val && collider.Contains("rForeArm"))
                {
                    RaeTriggerTrigger_p67("forearms", touchType);
                }
                else if (enableFeatures_p67["hands"].val && (collider.Contains("lCarpal") || collider.Contains("lHand")
                    || collider.Contains("lThumb1") || collider.Contains("lThumb2") || collider.Contains("lThumb3")
                    || collider.Contains("lIndex1") || collider.Contains("lIndex2") || collider.Contains("lIndex3")
                    || collider.Contains("lMid1") || collider.Contains("lMid2") || collider.Contains("lMid3")
                    || collider.Contains("lRing1") || collider.Contains("lRing2") || collider.Contains("lRing3")
                    || collider.Contains("lPinky1") || collider.Contains("lPinky2") || collider.Contains("lPinky3")
                    )
                )
                {
                    RaeTriggerTrigger_p67("hands", touchType);
                }
                else if (enableFeatures_p67["hands"].val && (collider.Contains("rCarpal") || collider.Contains("rHand")
                    || collider.Contains("rThumb1") || collider.Contains("rThumb2") || collider.Contains("rThumb3")
                    || collider.Contains("rIndex1") || collider.Contains("rIndex2") || collider.Contains("rIndex3")
                    || collider.Contains("rMid1") || collider.Contains("rMid2") || collider.Contains("rMid3")
                    || collider.Contains("rRing1") || collider.Contains("rRing2") || collider.Contains("rRing3")
                    || collider.Contains("rPinky1") || collider.Contains("rPinky2") || collider.Contains("rPinky3")
                    )
                )
                {
                    RaeTriggerTrigger_p67("hands", touchType);
                }
                else if (enableFeatures_p67["shins"].val && collider.Contains("rShin"))
                {
                    RaeTriggerTrigger_p67("shins", touchType);
                }
                else if (enableFeatures_p67["shins"].val && collider.Contains("lShin"))
                {
                    RaeTriggerTrigger_p67("shins", touchType);
                }
                else if (enableFeatures_p67["feet"].val && (collider.Contains("rFoot") || collider.Contains("rToe") || collider.Contains("rSmallToe") || collider.Contains("rBigToe")))
                {
                    RaeTriggerTrigger_p67("feet", touchType);
                }
                else if (enableFeatures_p67["feet"].val && (collider.Contains("lFoot") || collider.Contains("lToe") || collider.Contains("lSmallToe") || collider.Contains("lBigToe")))
                {
                    RaeTriggerTrigger_p67("feet", touchType);
                }

                else if (enableFeatures_p67["hip"].val && (collider.Contains("hip")))
                {
                    RaeTriggerTrigger_p67("hip", touchType);
                }
                else if (enableFeatures_p67["glutes"].val && (collider.Contains("Glute")))
                {
                    RaeTriggerTrigger_p67("glutes", touchType);
                }
                else if (enableFeatures_p67["gens"].val && (collider.Contains("ColliderGen") || collider.Contains("pelvis") || collider == "_Collider3"))
                {
                    
                    RaeTriggerTrigger_p67("gens", touchType);
                }
                else
                {
                }


            }
            catch (Exception e)
            {
                SuperController.LogError("Exception caught: " + e);
            }

        }



        public void HandleLoadPreset_p67(string path)
        {
            if (path == null) return;
            var jc = (JSONClass)LoadJSON(path);
            base.RestoreFromJSON(jc);

            foreach (var area in areas_p67)
            {
                myEventTriggers_p67["ontease" + area].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                myEventTriggers_p67["oncaress" + area].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                myEventTriggers_p67["onspank" + area].RestoreFromJSON(jc, base.subScenePrefix, false, true);
            }
           foreach (var area2 in tickletriggers_p67)
            {
                myEventTriggers_p67["ontease" + area2].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                myEventTriggers_p67["oncaress" + area2].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                myEventTriggers_p67["onspank" + area2].RestoreFromJSON(jc, base.subScenePrefix, false, true);
            }

            foreach (var item in playergazeworks_p67.lookAtCooldowns_p67)
            {
                myEventTriggers_p67["onGlance" + item.Key].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                myEventTriggers_p67["onGaze" + item.Key].RestoreFromJSON(jc, base.subScenePrefix, false, true);
                myEventTriggers_p67["onStare" + item.Key].RestoreFromJSON(jc, base.subScenePrefix, false, true);
            }


        }

        public void HandleSavePreset_p67(string path)
        {
            //SuperController.singleton.fileBrowserUI.fileFormat = null;
            if (path == null || path == "") return;
            if (!path.EndsWith("." + SaveExtension_p67))
            {
                path += "." + SaveExtension_p67;
            }
            var jc = GetJSON(true, true, true);
            SaveJSON(jc, path);
            SuperController.singleton.DoSaveScreenshot(path);
        }

        private void LoadFromJson_p67(JSONClass jsonClass)
        {
        }


        void UpdateMyString_p67(string name)
        {
        }


        public void CurrentClickedGameObject_p67(Vector3 click, Ray ray, GameObject gameObject, Collider collider)
        {

            Atom parent = null;
            var found = "";

            foreach (var component in collider.gameObject.GetComponentsInParent<Component>())
            {

                var atom = component as Atom;
                if (atom != null)
                {
                    parent = atom;
                    break;
                }
            }

            var RB = collider.attachedRigidbody;

            foreach (var xatom in SuperController.singleton.GetAtoms())
            {
                var RB2 = xatom.rigidbodies.First();
                if (RB == RB2)
                {
                    found = xatom.name;
                    break;
                }

            }

            var level = sliders_p67["touchdetection_tease"].val + 0.001f;
            if (Input.GetKey(KeyCode.LeftShift))
            {
                level = sliders_p67["touchdetection_caress"].val + 0.001f;
            }
            if (Input.GetKey(KeyCode.LeftControl))
            {
                level = sliders_p67["touchdetection_spank"].val + 0.001f;
            }

            foreach (var component in gameObject.GetComponentsInParent<Component>())
            {

                //SuperController.LogMessage("c: "+ collider);
                var atom = component as Atom;
                if (atom != null)
                {
                    var xname = found.Length > 0 ? found : atom.name;
                    if (atom.name != PersonAtom.name) return;
                    var xcollider = RB.name;
                    RaeClickTouch_p67("click", xname, parent.type, xcollider, level, collider);
                    break;
                }

            }

        }



        public void UpdateVarValue_p67(string s)
        {

        }



        public void debug_p67(string message)
        {
            if (debugMode_p67 == false) return;
            SuperController.LogMessage(message);
        }


        public IEnumerator CoroutineCreateAtom_p67(string type, string atomid)
        {
            yield return SuperController.singleton.AddAtomByType(type, atomid);
        }






        public void callbackenableFeaturesIdleBody_p67(bool val)
        {

        }



        Dictionary<string, JSONStorableString> titles = new Dictionary<string, JSONStorableString>();

        public void CreateTitle_p67(string id, string text, int fontsize, bool right, int spacing)
        {
            CreateTitle_p67(id, text, fontsize, right);
            SPQRUtils.CreateSpacer_p67(this, spacing, right);
        }

        public void CreateTitle_p67(string id, string text, int fontsize, bool right)
        {
            if (!titles.ContainsKey(id))
                titles.Add(id, new JSONStorableString("title " + id, "\n<size=" + fontsize + "><b>" + text + "</b></size>"));
            UIDynamicTextField title1text = CreateTextField(titles[id], right);
            title1text.UItext.supportRichText = true;
            title1text.backgroundColor = new Color(0f, 0f, 0f, 0f);
            title1text.textColor = new Color(0.42f, 0.03f, 0.51f, 1f);
            title1text.height = 100f;
            title1text.UItext.alignment = right ? TextAnchor.MiddleRight : TextAnchor.MiddleLeft;
        }

        public void L(string s)
        {
            SuperController.LogMessage(s);
        }
        public void E(string s)
        {
            SuperController.LogError(s);
        }
        public List<Transform> getRightUIElements_p67()
        {
            return rightUIElements;
        }
        public List<Transform> getLeftUIElements_p67()
        {
            return leftUIElements;
        }

        public Transform getUITransform_p67(bool rightSide)
        {
            return CreateUIElement(manager.configurableButtonPrefab.transform, rightSide);
        }

        public void PluginMessage_p67(string s)
        {
            //SuperController.LogMessage("received    ");
            //SuperController.LogMessage("PluginMessage_p67: " + s);
        }

    }







}

