using System;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using Random2 = System.Random;
using Random = UnityEngine.Random;



namespace SPQR
{

    public class Triggerworks
    {
        AliveTriggers X;
        public bool touchedBody = false;

        Dictionary <string, bool> checkTriggers_p67 = new Dictionary<string, bool>() {
            {"vaginaTrigger", false }
        };

        public Triggerworks(AliveTriggers script)
        {
            X = script;



        }

        public void Init_p67()
        {
           
        }

        public void BodyOnTouchEnter_p67(Collider other)
        {
            touchedBody = true;
        }

        public void BodyOnTouchExit_p67(Collider other)
        {
            touchedBody = false;
        }

        public bool allowHeadContactControl_p67() { 
            var collider = X.ephemeralString_p67["currentContact"];
            if (collider == "head") return false;
            if (collider == "chest") return false;
            if (collider == "neck") return false;
            if (collider == "lowerJaw") return false;
            if (collider.Contains("chest")) return false;
            return true;
        }
        public bool isJawTrigger_p67(string s)
        {
            if (s == "lowerJaw") return true;
            return false;
        }

        public bool isLeftHandTrigger_p67(string collider)
        {
            if (
                collider.Contains("lCarpal") || collider.Contains("lHand")
                || collider.Contains("lThumb1") || collider.Contains("lThumb2") || collider.Contains("lThumb3")
                || collider.Contains("lIndex1") || collider.Contains("lIndex2") || collider.Contains("lIndex3")
                || collider.Contains("lMid1") || collider.Contains("lMid2") || collider.Contains("lMid3")
                || collider.Contains("lRing1") || collider.Contains("lRing2") || collider.Contains("lRing3")
                || collider.Contains("lPinky1") || collider.Contains("lPinky2") || collider.Contains("lPinky3")
            ) return true;
            return false;

        }
        public bool isRightHandTrigger_p67(string collider)
        {
            if (    
                collider.Contains("rCarpal") || collider.Contains("rHand")
                || collider.Contains("rThumb1") || collider.Contains("rThumb2") || collider.Contains("rThumb3")
                || collider.Contains("rIndex1") || collider.Contains("rIndex2") || collider.Contains("rIndex3")
                || collider.Contains("rMid1") || collider.Contains("rMid2") || collider.Contains("rMid3")
                || collider.Contains("rRing1") || collider.Contains("rRing2") || collider.Contains("rRing3")
                || collider.Contains("rPinky1") || collider.Contains("rPinky2") || collider.Contains("rPinky3")
               ) return true;
            return false;

        }

        public bool isTongueTrigger_p67(string s)
        {
            if (s == "PhysicsMeshJoint4") return true;
            if (s == "PhysicsMeshJoint5") return true;
            if (s == "PhysicsMeshJoint6") return true;
            if (s == "PhysicsMeshJoint7") return true;
            if (s == "PhysicsMeshJoint8") return true;
            return false;
        }

        public bool isLipTrigger_p67(string s)
        {
            if (s == "LipTrigger") return true;
                //if (s == "PhysicsMeshJoint4") return true;
                //if (s == "PhysicsMeshJoint5") return true;
                //if (s == "PhysicsMeshJoint6") return true;
                //if (s == "PhysicsMeshJoint7") return true;
                //if (s == "PhysicsMeshJoint8") return true;
                return false;
        }

        public bool isMouthTrigger_p67(string s)
        {
            var ret = false;
            if (s == "MouthTrigger") ret = true;
            //if (s == "PhysicsMeshJoint10") return true;
            //if (s == "PhysicsMeshJoint11") return true;
            //if (s == "PhysicsMeshJoint18") return true;
            //if (s == "PhysicsMeshJoint19") return true;
            return ret;
        }

        public bool isThroatTrigger_p67(string s)
        {
            var ret = false;
            if (s == "ThroatTrigger") ret = true;
            //  if (s == "PhysicsMeshJoint25") return true;
            //if (s == "PhysicsMeshJoint20") return true;
            return ret;

        }

        public bool isPenetration_p67(string s)
        {
            if (s.Contains("CollidersrThigh") || s.Contains("ColliderslThigh")) return true;
            if (s.Contains("Colliderpelvis")) return true;
            return false;
        }

        public bool isNippleTrigger_p67(string s)
        {
            var ret = false;
            if (s == "lNippleTrigger") ret = true;
            if (s == "rNippleTrigger") ret = true;
            return ret;

        }
        public bool isLabiaTrigger_p67(string s)
        {
            if (!vanillaTriggerIsOn_p67("LabiaTrigger")) return false;
            var ret = false;
            if (s == "LabiaTrigger") ret = true;
            return ret;
        }
        public bool isVaginaTrigger_p67(string s)
        {
            if(!vanillaTriggerIsOn_p67("VaginaTrigger")) return false;
            //   bool changed = !checkTriggers_p67["vaginaTrigger"]  && vanillaTriggerIsOn_p67("VaginaTrigger");

            var ret = false;
            //if (vanillaTriggerIsOn_p67("VaginaTrigger") && vanillaTriggerIsOn_p67("LabiaTrigger") && changed)
            //{
            //    ret = true;
            //    checkTriggers_p67["vaginaTrigger"] = true;
            //    //   if (Time.time - X.timeline_p67["triggerVagina"] > 0.25f) ret = true;
            //}

                
            if (s == "VaginaTrigger") ret = true;
            if (ret)
            {
                X.timeline_p67["triggerVagina"] = Time.time;
              
            } else
            {
           //     checkTriggers_p67["vaginaTrigger"] = false;
            }
            return ret;
        }
        public bool isDeepVaginaTrigger_p67(string s)
        {
            if(!(vanillaTriggerIsOn_p67("VaginaTrigger") &&  vanillaTriggerIsOn_p67("DeepVaginaTrigger"))) return false;

            if (!vanillaTriggerIsOn_p67("VaginaTrigger")) return false;
            if (Time.time - X.timeline_p67["triggerVagina"] > 10f) return false;
            var ret = false;
            if (s == "DeepVaginaTrigger") return true;
            return ret;
        }
        public bool isDeeperVaginaTrigger_p67(string s)
        {
            if (!(vanillaTriggerIsOn_p67("VaginaTrigger") && vanillaTriggerIsOn_p67("DeepVaginaTrigger") && vanillaTriggerIsOn_p67("DeeperVaginaTrigger"))) return false;
            if (!vanillaTriggerIsOn_p67("VaginaTrigger")) return false;
            if (!vanillaTriggerIsOn_p67("DeepVaginaTrigger")) return false;
            if (Time.time - X.timeline_p67["triggerVagina"] > 10f) return false;
            var ret = false;
            if (s == "DeeperVaginaTrigger") return true;
            return ret;
        }

        public bool customTriggerAllowed_p67(string sender)
        {
            if (isLipTrigger_p67(sender)) return true;
            if (isMouthTrigger_p67(sender)) return true;
            if (isThroatTrigger_p67(sender)) return true;
            if (isNippleTrigger_p67(sender)) return true;
            if (isLabiaTrigger_p67(sender)) return true;
            if (isVaginaTrigger_p67(sender)) return true;
            if (isDeepVaginaTrigger_p67(sender)) return true;
            if (isDeeperVaginaTrigger_p67(sender)) return true;
            return false;
        }

        public bool VanillaIsBySelf_p67(CollisionTrigger ct)
        {
            bool isSelf = true;
            CollisionTriggerEventHandler cteh = ct.GetComponentInChildren<CollisionTriggerEventHandler>();
            if (cteh == null) return false;
            if (cteh.collidingWithDictionary.Count > 0f)
            {
             
                for (var i = 0; i < cteh.collidingWithDictionary.Count; i++)
                {
                    var collider = cteh.collidingWithDictionary.ElementAt(i).Key;
                    if (collider == null) continue;
                    var parent = SPQRUtils.getAtomFromTransform_p67(collider.transform);
                    if (parent == null) continue;
                    if (parent.type == "CollisionTrigger") continue;
                    if (parent.name != X.PersonAtom.uid)
                    {
                      //SuperController.LogMessage("notself: " + parent.type);
                        isSelf = false;
                    }
                }
                
            }
            return isSelf;
        }


        public bool vanillaTriggerIsOn_p67(string trigger)
        {
            CollisionTrigger ct = X.PersonAtom.GetStorableByID(trigger) as CollisionTrigger;

            var returnVal = ct.trigger.active;
            if (returnVal)
            {
                switch (trigger)
                {
                    case "VaginaTrigger":
                    case "DeepVaginaTrigger":
                    case "DeeperVaginaTrigger":
                        if (VanillaIsBySelf_p67(ct)) return false;
                        break;
                }
            }
            if (returnVal)
            {
               
            }
            return returnVal;
        }


    }


}