using System;
using System.Globalization;
using UnityEngine;
using UnityEngine.XR;
using System.Text;
using System.Linq;
using System.Collections;
using System.Collections.Generic;
using SimpleJSON;
using UnityEngine.XR;
using MVR.FileManagementSecure;
using Random2 = System.Random;
using Random = UnityEngine.Random;


namespace SPQR
{

    public class Playergazeworks
    {
        AliveTriggers X;
        public Rigidbody centerEye_p67;

        float maxDistanceLookAt_p67 = 10f;

        float lookAtCooldownIncrement_p67 = 0.2f * 3f;
        float lookAtCooldownMax_p67 = 10f;

        string lastGaze_p67 = "";

        GameObject gazeLine_p67;
        LineRenderer gazeLineComponent_p67;
        float gazeLineWidth_p67 = 0.2f;

        public Dictionary<string, float> lookAtCooldowns_p67 = new Dictionary<string, float>() {
            { "head", 0f },
            { "breasts", 0f },
            { "genitals", 0f }
        };
        public Dictionary<string, float> lookAtTresholds_p67 = new Dictionary<string, float>() {
            { "glance", 1f },
            { "gaze", 3f },
            { "stare", 7f }
        };



        public Playergazeworks(AliveTriggers script)
        {
            X = script;
            centerEye_p67 = SuperController.singleton.RigidbodyNameToRigidbody("[CameraRig]:CenterEye");

            OnEnable_p67();
            
        }
        public void OnDestroy_p67()
        {
            UnityEngine.Object.Destroy(gazeLineComponent_p67);
            UnityEngine.Object.Destroy(gazeLine_p67);
        }

        public void OnDisable_p67()
        {
            UnityEngine.Object.Destroy(gazeLineComponent_p67);
            UnityEngine.Object.Destroy(gazeLine_p67);
        }
        public void OnEnable_p67()
        {
            //AddGazeLine_p67();
        }
        public void AddGazeLine_p67()
        {
            gazeLine_p67 = GameObject.Find("AliveGazeLine");
            if (gazeLine_p67 == null)
            {
                gazeLine_p67 = new GameObject("AliveGazeLine");
                gazeLineComponent_p67 = gazeLine_p67.AddComponent<LineRenderer>();

            }
            else
            {
                gazeLineComponent_p67 = gazeLine_p67.GetComponent<LineRenderer>();
            }
            if (gazeLineComponent_p67 != null)
            {
                gazeLineComponent_p67.startWidth = 0.0f;
                gazeLineComponent_p67.endWidth = 0.1f;
                gazeLineComponent_p67.startColor = Color.red;
                gazeLineComponent_p67.endColor = Color.red;
            }
        }
        public void Update_p67()
        {
            try
            {
                var allzero = 0f;

                List<string> keys = new List<string>(lookAtCooldowns_p67.Keys);

                foreach (var item in keys)
                {
                    if (lookAtCooldowns_p67[item] > 0f)
                    {
                        lookAtCooldowns_p67[item] -= Time.deltaTime;
                        if (lookAtCooldowns_p67[item] < 0f) lookAtCooldowns_p67[item] = 0f;
                        allzero += lookAtCooldowns_p67[item];
                    }
                }
                if (allzero == 0f) lastGaze_p67 = "";
            }catch(Exception e)
            {
                X.E("err:" + e);
            }
     
          
        }
        public void FixedUpdate_p67()
        {
            if (gazeLineComponent_p67 == null) return;
            gazeLineComponent_p67.SetPosition(0, centerEye_p67.transform.position);
            var dest = centerEye_p67.transform.position + centerEye_p67.transform.forward * 10f;
            gazeLineComponent_p67.SetPosition(1, dest);

        }
     public void UpdateConstant5_p67()
        {
            RaycastHit hit;
          
            if (Physics.Raycast(centerEye_p67.transform.position, centerEye_p67.transform.forward, out hit, maxDistanceLookAt_p67, Physics.DefaultRaycastLayers, QueryTriggerInteraction.Ignore))
            {
                if (hit.collider.gameObject != null)
                {
                    var a = SPQRUtils.getAtomFromTransform_p67(hit.collider.gameObject.transform);
                    if (a == null) return;
                    PersonLooksAt_p67(hit.collider, a, hit.collider.gameObject.name);


                }

            }
        }

    public void PersonLooksAt_p67(Collider c, Atom a, string name)
        {
            if(a.uid == X.PersonAtom.uid)
            {
            //    X.L("l: " + name);
                PersonLooksAtModel_p67(c, a, name);
                return;
            }
        }

        public void PersonLooksAtModel_p67(Collider c, Atom a, string name)
        {
            string found = "";

            //head_p67
            if (name.Contains("AliveBreathingAudio")) found = "head";
            if (name.Contains("CollidersHead")) found = "head";
            
            //breasts
            if (name.Contains("NippleControl")) found = "breasts";

            //genitals
            if (name.Contains("Colliderpelvis")) found = "genitals";
            if (name.Contains("Collidersabdomen")) found = "genitals";

         //   X.L("look at " + found + " (" + lookAtCooldowns_p67[found] + ")");


            if (found.Length > 0)
            {
                lookAtCooldowns_p67[found] += lookAtCooldownIncrement_p67;
                if(lookAtCooldowns_p67[found] > lookAtCooldownMax_p67) lookAtCooldowns_p67[found] = lookAtCooldownMax_p67;

                if (X.buttons_p67.ContainsKey("onGlance"+found)) {
                    if (lookAtCooldowns_p67[found] >= lookAtTresholds_p67["stare"])
                    {
                        if (lastGaze_p67 == "onStare" + found) return;
                        lastGaze_p67 = "onStare" + found;
                        X.RaeTriggerTrigger_p67(found, "Stare");
                    }
                    else if (lookAtCooldowns_p67[found] >= lookAtTresholds_p67["gaze"])
                    {
                        if (lastGaze_p67 == "onGaze" + found) return;
                        lastGaze_p67 = "onGaze" + found;
                        X.RaeTriggerTrigger_p67(found,"Gaze");
                    }
                    else if (lookAtCooldowns_p67[found] >= lookAtTresholds_p67["glance"])
                    {
                        if (lastGaze_p67 == "onGlance" + found) return;
                        lastGaze_p67 = "onGlance" + found;
                        X.RaeTriggerTrigger_p67(found, "Glance");
                    }

                }

                
            }
        }

        

    }

}